package edu.mermet.tp8.actions;

import java.awt.event.ActionEvent;
import java.awt.event.InputEvent;
import java.awt.event.KeyEvent;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.Properties;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.KeyStroke;
import javax.swing.event.InternalFrameListener;

import edu.mermet.tp8.Application;
import edu.mermet.tp8.ecouteur.EcouteurAfficher;
import edu.mermet.tp8.ecouteur.EcouteurAuto;

public class ActionAfficherTexte extends AbstractAction {
	private Application a;
    public ActionAfficherTexte(Application a) {
        super("Saisie de texte");
        this.a = a;
        
        putValue(Action.ACCELERATOR_KEY,KeyStroke.getKeyStroke(KeyEvent.VK_T, InputEvent.CTRL_DOWN_MASK));
        putValue(Action.MNEMONIC_KEY,KeyEvent.VK_T);
    }

    @Override
    public void actionPerformed(ActionEvent ae) {
    	
    	try (InputStream input = new FileInputStream("src/main/java/edu/mermet/tp8/configuration/bouton.properties")) {
			
    		Properties p = System.getProperties();
        	String name = p.getProperty("user.name");
    		
			Properties prop = new Properties();

            prop.load(input);
            
            InternalFrameListener[] listener = a.getFenetreTexte().getInternalFrameListeners();
        	for(int i = 0; i < listener.length; i++) {
        		a.getFenetreTexte().removeInternalFrameListener(listener[i]);
        	}
            
            if(prop.getProperty("texte"+name).contains("Auto")) {
            	a.getFenetreTexte().setVisible(true);
            	a.getFenetreTexte().addInternalFrameListener(new EcouteurAuto(a.getFenetreTexte(), this));           	
                a.enableTexte(false);
            }else if (prop.getProperty("texte"+name).contains("Afficher")) {
            	a.getFenetreTexte().setVisible(true);
            	a.getFenetreTexte().addInternalFrameListener(new EcouteurAfficher(a.getFenetreTexte(), this));
                a.enableTexte(false);
            }else {
            	a.getFenetreTexte().setVisible(false);            	 
                a.enableTexte(false);
            }
            
		}catch (IOException ex) {
            ex.printStackTrace();
        }
    }
}
